
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="fr">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Sommet &#8212; Documentation Segmentation Image 3.0</title>
    <link rel="stylesheet" href="../_static/nature.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/translations.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Recherche" href="../search.html" /> 
  </head><body>
<div style="background-color: white; text-align: left; padding: 10px 10px 15px 15px">
  <a href="../index.html">
  <img src="../_static/logo.png" border="0" alt="Segmentation Image"/>
  </a>
</div>

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="Index général"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Index des modules Python"
             >modules</a> |</li>
<li><a href="../index.html">Segmentation Image home</a>| </li>
<li><a href="../contents.html">Documentation </a> &raquo;</li>

          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">Code du module</a> &#187;</li> 
      </ul>
    </div>

      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Recherche rapide</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Code source de Sommet</h1><div class="highlight"><pre>
<span></span><span class="c1">#####################################</span>
<span class="c1"># Cecile Prouteau</span>
<span class="c1"># CTES Projet Math-Info</span>
<span class="c1"># Projet segmentation d&#39;image</span>
<span class="c1"># 15/01/2019</span>
<span class="c1"># Classe Sommet Version 3.0</span>
<span class="c1">#####################################</span>
<span class="kn">import</span> <span class="nn">math</span>

<span class="c1">### DEBUT de la classe Sommet</span>
<span class="c1">### contient la recherche des voisins , on se place du point de vue des coordonnées sur l&#39;image</span>
<div class="viewcode-block" id="Sommet"><a class="viewcode-back" href="../tec_doc - Copie.html#Sommet.Sommet">[docs]</a><span class="k">class</span> <span class="nc">Sommet</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>

<span class="sd">    **LES METHODES**</span>
<span class="sd">     </span>
<span class="sd">    &quot;&quot;&quot;</span>
    
<div class="viewcode-block" id="Sommet.__init__"><a class="viewcode-back" href="../tec_doc - Copie.html#Sommet.Sommet.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">,</span><span class="nb">id</span><span class="p">,</span><span class="n">v</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Constructeur d&#39;un objet Sommet</span>
<span class="sd">        </span>
<span class="sd">        Construit un sommet à partir des coordonnées d&#39;un pixel sur une image</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Sommet </span>
<span class="sd">        :type self: Sommet</span>
<span class="sd">        </span>
<span class="sd">        :param x: abscisse du point sur l&#39;image</span>
<span class="sd">        :type FilePath: int  </span>
<span class="sd">        </span>
<span class="sd">        </span>
<span class="sd">        :param y: ordonnée du point  </span>
<span class="sd">        :type FilePath: int      </span>
<span class="sd">        </span>
<span class="sd">        :return: Objet Sommet</span>
<span class="sd">        :rtype: Sommet</span>
<span class="sd">        </span>
<span class="sd">        Liste des champs de la classe</span>
<span class="sd">        </span>
<span class="sd">        * self.x abscisse </span>
<span class="sd">        * self.y ordonnée</span>
<span class="sd">        * self.v valeur du sommet self</span>
<span class="sd">        * self.id numéro d&#39;identification unique du sommet dans la liste des sommets.</span>
<span class="sd">        * self.dist distance à la source. Intialisée à math.inf</span>
<span class="sd">        * self.id_pere numéro de sommet du père du sommet dans chemin de parcours du graphe. Intialisé à None</span>
<span class="sd">        * self.pere id du sommet père du sommet dans chemin de parcours du graphe. Intialisé à None</span>
<span class="sd">        * self.etat état donné au sommet lors du parcours du graphe. Intialisé à None pour non visité, passera à 0 pour visité et à 1 quand traité.</span>
<span class="sd">        * self.zone numéro de zone du pixel </span>
<span class="sd">        </span>
<span class="sd">        Pour les lignes et les colonnes je me place du point de vue de l&#39;image. </span>
<span class="sd">        Dans le tableau numpy, les coordonnées sont inversées.</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">x</span><span class="o">=</span><span class="n">x</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="o">=</span><span class="n">y</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">v</span><span class="o">=</span><span class="n">v</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">id</span><span class="o">=</span><span class="nb">id</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">dist</span><span class="o">=</span><span class="n">math</span><span class="o">.</span><span class="n">inf</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">id_pere</span><span class="o">=</span><span class="kc">None</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">pere</span><span class="o">=</span><span class="kc">None</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">etat</span><span class="o">=</span><span class="kc">None</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">zone</span><span class="o">=</span><span class="kc">None</span></div>
        
<div class="viewcode-block" id="Sommet.maj_id"><a class="viewcode-back" href="../tec_doc - Copie.html#Sommet.Sommet.maj_id">[docs]</a>    <span class="k">def</span> <span class="nf">maj_id</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">val</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Procedure qui met à jour l&#39;attribu self.id avec la valeur val</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Sommet </span>
<span class="sd">        :type self: Sommet</span>
<span class="sd">        </span>
<span class="sd">        :param val: entier à pour mise à jour du numéro de sommet</span>
<span class="sd">        :type val: int  </span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">id</span><span class="o">=</span><span class="n">val</span></div>
        
<div class="viewcode-block" id="Sommet.maj_dist"><a class="viewcode-back" href="../tec_doc - Copie.html#Sommet.Sommet.maj_dist">[docs]</a>    <span class="k">def</span> <span class="nf">maj_dist</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">val</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Procedure qui met à jour l&#39;attribu self.dist avec la valeur val</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Sommet </span>
<span class="sd">        :type self: Sommet</span>
<span class="sd">        </span>
<span class="sd">        :param val: entier à pour mise à jour du numéro de sommet</span>
<span class="sd">        :type val: int  </span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">dist</span><span class="o">=</span><span class="n">val</span></div>
        
<div class="viewcode-block" id="Sommet.maj_etat"><a class="viewcode-back" href="../tec_doc - Copie.html#Sommet.Sommet.maj_etat">[docs]</a>    <span class="k">def</span> <span class="nf">maj_etat</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">val</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Procedure qui met à jour l&#39;attribu self.etat avec la valeur val</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Sommet </span>
<span class="sd">        :type self: Sommet</span>
<span class="sd">        </span>
<span class="sd">        :param val: entier à pour mise à jour de l&#39;état du sommet (None = non visité, 0 = visité, 1 = traité)</span>
<span class="sd">        :type val: int  </span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">etat</span><span class="o">=</span><span class="n">val</span></div>
        
<div class="viewcode-block" id="Sommet.maj_id_pere"><a class="viewcode-back" href="../tec_doc - Copie.html#Sommet.Sommet.maj_id_pere">[docs]</a>    <span class="k">def</span> <span class="nf">maj_id_pere</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">id_pere</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Procedure qui met à jour l&#39;attribu self.id_pere avec la valeur id_pere</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Sommet </span>
<span class="sd">        :type self: Sommet</span>
<span class="sd">        </span>
<span class="sd">        :param id_pere: entier pour mise à jour du numéro de sommet du pere self.id_pere</span>
<span class="sd">        :type id_pere: int  </span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">pere</span><span class="o">=</span><span class="n">id_pere</span></div>
        
<div class="viewcode-block" id="Sommet.maj_pere"><a class="viewcode-back" href="../tec_doc - Copie.html#Sommet.Sommet.maj_pere">[docs]</a>    <span class="k">def</span> <span class="nf">maj_pere</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">pere</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Procedure qui met à jour l&#39;attribu self.pere avec la valeur pere</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Sommet </span>
<span class="sd">        :type self: Sommet</span>
<span class="sd">        </span>
<span class="sd">        :param pere: Objet Sommet pour mise à jour du sommet du pere self.pere</span>
<span class="sd">        :type pere: Sommet  </span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">pere</span><span class="o">=</span><span class="n">id_pere</span></div>
        
<div class="viewcode-block" id="Sommet.maj_zone"><a class="viewcode-back" href="../tec_doc - Copie.html#Sommet.Sommet.maj_zone">[docs]</a>    <span class="k">def</span> <span class="nf">maj_zone</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">val</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Procedure qui met à jour l&#39;attribu self.id avec la valeur val</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Sommet </span>
<span class="sd">        :type self: Sommet</span>
<span class="sd">        </span>
<span class="sd">        :param val: entier à pour mise à jour du numéro de sommet</span>
<span class="sd">        :type val: int  </span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">zone</span><span class="o">=</span><span class="n">val</span></div>
    
<div class="viewcode-block" id="Sommet.coord_voisin"><a class="viewcode-back" href="../tec_doc - Copie.html#Sommet.Sommet.coord_voisin">[docs]</a>    <span class="k">def</span> <span class="nf">coord_voisin</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">direction</span><span class="p">):</span>
        
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        :param self: Objet Sommet </span>
<span class="sd">        :type self: Sommet</span>
<span class="sd">        </span>
<span class="sd">        :param direction: chaine de caractère parmi &#39;droite&#39;, &#39;gauche&#39;, &#39;haut&#39;, &#39;bas&#39;</span>
<span class="sd">        :type direction: str  </span>
<span class="sd">        </span>
<span class="sd">        :return: un couple de coordonnée entières (x&#39;, y&#39;) du pixel voisin de celui de coordonnée (x,y) dans la direction indiquée par la variable direction. </span>
<span class="sd">        :rtype: int*int</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="k">if</span> <span class="n">direction</span><span class="o">==</span><span class="s1">&#39;droite&#39;</span><span class="p">:</span>
            <span class="k">return</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x</span><span class="o">+</span><span class="mi">1</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">direction</span><span class="o">==</span><span class="s1">&#39;gauche&#39;</span><span class="p">:</span>
            <span class="k">return</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">direction</span><span class="o">==</span><span class="s1">&#39;haut&#39;</span><span class="p">:</span>
            <span class="k">return</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="o">-</span><span class="mi">1</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">direction</span><span class="o">==</span><span class="s1">&#39;bas&#39;</span><span class="p">:</span>
            <span class="k">return</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span>
        <span class="k">else</span> <span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Erreur de paramètre dans Sommet.coord_voisin!&quot;</span><span class="p">)</span>  
            <span class="n">exit</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span> </div>
             
<div class="viewcode-block" id="Sommet.est_egal"><a class="viewcode-back" href="../tec_doc - Copie.html#Sommet.Sommet.est_egal">[docs]</a>    <span class="k">def</span> <span class="nf">est_egal</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">sommet</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Sommet </span>
<span class="sd">        :type self: Sommet</span>
<span class="sd">        </span>
<span class="sd">        :param sommet: Objet Sommet</span>
<span class="sd">        :type sommet: Sommet  </span>
<span class="sd">        </span>
<span class="sd">        :param y: ordonnée du point  </span>
<span class="sd">        :type FilePath: int      </span>
<span class="sd">        </span>
<span class="sd">        :return: True si self et sommet ont les même coordonnées et False sinon</span>
<span class="sd">        :rtype: bool</span>
<span class="sd">        &quot;&quot;&quot;</span> 
        <span class="k">return</span>  <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">id</span><span class="o">==</span><span class="n">sommet</span><span class="o">.</span><span class="n">id</span><span class="p">)</span>   </div>
            
<div class="viewcode-block" id="Sommet.affiche_sommet"><a class="viewcode-back" href="../tec_doc - Copie.html#Sommet.Sommet.affiche_sommet">[docs]</a>    <span class="k">def</span> <span class="nf">affiche_sommet</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Affiche les coordonnées de self</span>
<span class="sd">        </span>
<span class="sd">        :param self: Objet Sommet </span>
<span class="sd">        :type self: Sommet</span>
<span class="sd">        </span>
<span class="sd">        :return: None </span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;(</span><span class="si">%d</span><span class="s2">,</span><span class="si">%d</span><span class="s2">)&quot;</span><span class="o">%</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="p">),</span><span class="n">end</span><span class="o">=</span><span class="s2">&quot;;&quot;</span><span class="p">)</span>        </div></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="Index général"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Index des modules Python"
             >modules</a> |</li>
<li><a href="../index.html">Segmentation Image home</a>| </li>
<li><a href="../contents.html">Documentation </a> &raquo;</li>

          <li class="nav-item nav-item-1"><a href="index.html" >Code du module</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2019, Cecile Prouteau.
      Créé avec <a href="http://sphinx-doc.org/">Sphinx</a> 1.7.9.
    </div>
  </body>
</html>